package eu.eudat.commons.types.prefilling;

import eu.eudat.commons.JsonHandlingService;

import java.util.Map;

public class PrefillingEntity {
    private String pid;
    private String name;
    private Map<String, Object> data;
    private String key;
    private String tag;

    public String getPid() {
        return pid;
    }

    public void setPid(String pid) {
        this.pid = pid;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Map<String, Object> getData() {
        return data;
    }

    public void setData(Map<String, Object> data) {
        this.data = data;
    }

    public String getKey() {
        return key;
    }

    public void setKey(String key) {
        this.key = key;
    }

    public String getTag() {
        return tag;
    }

    public void setTag(String tag) {
        this.tag = tag;
    }
    
    public static PrefillingEntity build(Map<String, String> fetchedData, JsonHandlingService jsonHandlingService){
        PrefillingEntity m = new PrefillingEntity();

        m.setPid(fetchedData.getOrDefault("pid", null));
        m.setName(fetchedData.getOrDefault("name", null));
        m.setKey(fetchedData.getOrDefault("key", null));
        m.setTag(fetchedData.getOrDefault("tag", null));
        m.setData(jsonHandlingService.fromJsonSafe(Map.class,fetchedData.getOrDefault("data",  null)));
        
        return m;
    }
}
