package eu.eudat.commons.types.referencetype;

import eu.eudat.commons.enums.FieldType;
import eu.eudat.commons.enums.ReferenceTypeSourceType;
import eu.eudat.commons.types.descriptiontemplate.importexport.fielddata.*;
import jakarta.xml.bind.annotation.*;

import java.util.List;

@XmlRootElement(name = "definition")
@XmlAccessorType(XmlAccessType.FIELD)
public class ReferenceTypeDefinitionEntity {
	@XmlElementWrapper(name = "fields")
	@XmlElement(name = "field")
	private List<ReferenceTypeFieldEntity> fields;

	@XmlElementWrapper(name = "sources")
	@XmlElements({
			@XmlElement(name = ReferenceTypeSourceType.Names.API, type = ReferenceTypeSourceExternalApiConfigurationEntity.class),
			@XmlElement(name = ReferenceTypeSourceType.Names.STATIC, type = ReferenceTypeSourceStaticOptionConfigurationEntity.class),
	})
	private List<ReferenceTypeSourceBaseConfigurationEntity> sources;

	public List<ReferenceTypeFieldEntity> getFields() {
		return fields;
	}

	public void setFields(List<ReferenceTypeFieldEntity> fields) {
		this.fields = fields;
	}

	public List<ReferenceTypeSourceBaseConfigurationEntity> getSources() {
		return sources;
	}

	public void setSources(List<ReferenceTypeSourceBaseConfigurationEntity> sources) {
		this.sources = sources;
	}
}
