package eu.eudat.configurations.referencetype;

import eu.eudat.model.persist.referencedefinition.DefinitionPersist;
import eu.eudat.model.referencedefinition.Field;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.boot.context.properties.bind.ConstructorBinding;

import java.util.List;
import java.util.Map;

@ConfigurationProperties(prefix = "reference-type")
public class ReferenceTypeProperties {

    private Map<String, List<ReferenceTypeField>> grant;
    private Map<String, List<ReferenceTypeField>> funder;
    private Map<String, List<ReferenceTypeField>> researcher;
    private Map<String, List<ReferenceTypeField>> service;
    private Map<String, List<ReferenceTypeField>> registry;
    private Map<String, List<ReferenceTypeField>> project;
    private Map<String, List<ReferenceTypeField>> organisation;
    private Map<String, List<ReferenceTypeField>> dataset;
    private Map<String, List<ReferenceTypeField>> dataRepository;
    private Map<String, List<ReferenceTypeField>> pubRepository;
    private Map<String, List<ReferenceTypeField>> journal;
    private Map<String, List<ReferenceTypeField>> publication;
    private Map<String, List<ReferenceTypeField>> licence;
    private Map<String, List<ReferenceTypeField>> taxonomy;

    @ConstructorBinding
    public ReferenceTypeProperties(Map<String, List<ReferenceTypeField>> grant, Map<String, List<ReferenceTypeField>> funder,
                                   Map<String, List<ReferenceTypeField>> researcher, Map<String, List<ReferenceTypeField>> service,
                                   Map<String, List<ReferenceTypeField>> registry, Map<String, List<ReferenceTypeField>> project,
                                   Map<String, List<ReferenceTypeField>> organisation, Map<String, List<ReferenceTypeField>> dataset,
                                   Map<String, List<ReferenceTypeField>> dataRepository, Map<String, List<ReferenceTypeField>> pubRepository,
                                   Map<String, List<ReferenceTypeField>> journal, Map<String, List<ReferenceTypeField>> publication,
                                   Map<String, List<ReferenceTypeField>> licence, Map<String, List<ReferenceTypeField>> taxonomy) {
        this.grant = grant;
        this.funder = funder;
        this.researcher = researcher;
        this.service = service;
        this.registry = registry;
        this.project = project;
        this.organisation = organisation;
        this.dataset = dataset;
        this.dataRepository = dataRepository;
        this.pubRepository = pubRepository;
        this.journal = journal;
        this.publication = publication;
        this.licence = licence;
        this.taxonomy = taxonomy;
    }

    public Map<String, List<ReferenceTypeField>> getGrant() {
        return grant;
    }

    public void setGrant(Map<String, List<ReferenceTypeField>> grant) {
        this.grant = grant;
    }

    public Map<String, List<ReferenceTypeField>> getFunder() {
        return funder;
    }

    public void setFunder(Map<String, List<ReferenceTypeField>> funder) {
        this.funder = funder;
    }

    public Map<String, List<ReferenceTypeField>> getResearcher() {
        return researcher;
    }

    public void setResearcher(Map<String, List<ReferenceTypeField>> researcher) {
        this.researcher = researcher;
    }

    public Map<String, List<ReferenceTypeField>> getService() {
        return service;
    }

    public void setService(Map<String, List<ReferenceTypeField>> service) {
        this.service = service;
    }

    public Map<String, List<ReferenceTypeField>> getRegistry() {
        return registry;
    }

    public void setRegistry(Map<String, List<ReferenceTypeField>> registry) {
        this.registry = registry;
    }

    public Map<String, List<ReferenceTypeField>> getProject() {
        return project;
    }

    public void setProject(Map<String, List<ReferenceTypeField>> project) {
        this.project = project;
    }

    public Map<String, List<ReferenceTypeField>> getOrganisation() {
        return organisation;
    }

    public void setOrganisation(Map<String, List<ReferenceTypeField>> organisation) {
        this.organisation = organisation;
    }

    public Map<String, List<ReferenceTypeField>> getDataset() {
        return dataset;
    }

    public void setDataset(Map<String, List<ReferenceTypeField>> dataset) {
        this.dataset = dataset;
    }

    public Map<String, List<ReferenceTypeField>> getDataRepository() {
        return dataRepository;
    }

    public void setDataRepository(Map<String, List<ReferenceTypeField>> dataRepository) {
        this.dataRepository = dataRepository;
    }

    public Map<String, List<ReferenceTypeField>> getPubRepository() {
        return pubRepository;
    }

    public void setPubRepository(Map<String, List<ReferenceTypeField>> pubRepository) {
        this.pubRepository = pubRepository;
    }

    public Map<String, List<ReferenceTypeField>> getJournal() {
        return journal;
    }

    public void setJournal(Map<String, List<ReferenceTypeField>> journal) {
        this.journal = journal;
    }

    public Map<String, List<ReferenceTypeField>> getPublication() {
        return publication;
    }

    public void setPublication(Map<String, List<ReferenceTypeField>> publication) {
        this.publication = publication;
    }

    public Map<String, List<ReferenceTypeField>> getLicence() {
        return licence;
    }

    public void setLicence(Map<String, List<ReferenceTypeField>> licence) {
        this.licence = licence;
    }

    public Map<String, List<ReferenceTypeField>> getTaxonomy() {
        return taxonomy;
    }

    public void setTaxonomy(Map<String, List<ReferenceTypeField>> taxonomy) {
        this.taxonomy = taxonomy;
    }
}
