package eu.eudat.model.persist.descriptionproperties;

import eu.eudat.commons.types.descriptiontemplate.FieldSetEntity;
import eu.eudat.commons.validation.BaseValidator;
import eu.eudat.convention.ConventionService;
import eu.eudat.errorcode.ErrorThesaurusProperties;
import gr.cite.tools.validation.ValidatorFactory;
import gr.cite.tools.validation.specification.Specification;
import org.springframework.context.MessageSource;
import org.springframework.stereotype.Component;

import java.util.Arrays;
import java.util.List;

public class PropertyDefinitionFieldSetPersist {

    public final static String _items = "items";
    private List<PropertyDefinitionFieldSetItemPersist> items;

    public List<PropertyDefinitionFieldSetItemPersist> getItems() {
        return items;
    }

    public void setItems(List<PropertyDefinitionFieldSetItemPersist> items) {
        this.items = items;
    }

    @Component(PersistValidator.ValidatorName)
    public static class PersistValidator extends BaseValidator<PropertyDefinitionFieldSetPersist> {

        public static final String ValidatorName = "Description.PropertyDefinitionFieldSetPersistValidator";
        private final ValidatorFactory validatorFactory;
        private FieldSetEntity fieldSetEntity;
        protected PersistValidator(ConventionService conventionService, ErrorThesaurusProperties errors, ValidatorFactory validatorFactory, MessageSource messageSource) {
            super(conventionService, errors);
	        this.validatorFactory = validatorFactory;
        }

        @Override
        protected Class<PropertyDefinitionFieldSetPersist> modelClass() {
            return PropertyDefinitionFieldSetPersist.class;
        }

        @Override
        protected List<Specification> specifications(PropertyDefinitionFieldSetPersist item) {
            return Arrays.asList(
                    this.navSpec()
                            .iff(() -> !this.isNull(item.getItems()))
                            .on(PropertyDefinitionFieldSetPersist._items)
                            .over(item.getItems())
                            .using((itm) -> this.validatorFactory.validator(PropertyDefinitionFieldSetItemPersist.PersistValidator.class).withFieldSetEntity(this.fieldSetEntity))
                    );
        }

        public PersistValidator withFieldSetEntity(FieldSetEntity fieldSetEntity) {
            this.fieldSetEntity = fieldSetEntity;
            return this;
        }
    }

}


