package eu.eudat.service.fielddatahelper;

import eu.eudat.authorization.AuthorizationFlags;
import eu.eudat.commons.types.descriptiontemplate.fielddata.LabelAndMultiplicityDataEntity;
import eu.eudat.commons.types.descriptiontemplate.importexport.fielddata.LabelAndMultiplicityDataImportExport;
import eu.eudat.model.builder.descriptiontemplatedefinition.fielddata.LabelAndMultiplicityDataBuilder;
import eu.eudat.model.descriptiontemplatedefinition.fielddata.LabelAndMultiplicityData;
import eu.eudat.model.persist.descriptiontemplatedefinition.fielddata.LabelAndMultiplicityDataPersist;
import gr.cite.tools.data.builder.BuilderFactory;
import gr.cite.tools.fieldset.FieldSet;
import gr.cite.tools.validation.Validator;
import gr.cite.tools.validation.ValidatorFactory;
import org.springframework.stereotype.Component;

import java.util.EnumSet;
import java.util.List;

@Component
public class LabelAndMultiplicityFieldDataHelperService extends BaseFieldDataHelperService<LabelAndMultiplicityData, LabelAndMultiplicityDataPersist, LabelAndMultiplicityDataEntity, LabelAndMultiplicityDataImportExport> {
	
	private final BuilderFactory builderFactory;

	private final ValidatorFactory validatorFactory;
	public LabelAndMultiplicityFieldDataHelperService(BuilderFactory builderFactory, ValidatorFactory validatorFactory) {
		this.builderFactory = builderFactory;
		this.validatorFactory = validatorFactory;
	}

	@Override
	public LabelAndMultiplicityDataEntity newDataInstanceInternal() {
		return new LabelAndMultiplicityDataEntity();
	}

	@Override
	public LabelAndMultiplicityData newModelInstanceInternal() {
		return new LabelAndMultiplicityData();
	}

	@Override
	public LabelAndMultiplicityDataPersist newPersistModelInstanceInternal() {
		return new LabelAndMultiplicityDataPersist();
	}

	@Override
	protected LabelAndMultiplicityDataImportExport newImportExportInstanceInternal() {
		return new LabelAndMultiplicityDataImportExport();
	}

	@Override
	public Class<?> getDataClass() {
		return LabelAndMultiplicityDataEntity.class;
	}
	@Override
	public Class<?> getModelClass() {
		return LabelAndMultiplicityData.class;
	}
	@Override
	public Class<?> getPersistModelClass() {
		return LabelAndMultiplicityDataPersist.class;
	}

	@Override
	public Class<?> getImportExportClass() {
		return LabelAndMultiplicityDataImportExport.class;
	}
	
	@Override
	public Validator getPersistModelValidator() {
		return this.validatorFactory.validator(LabelAndMultiplicityDataPersist.LabelAndMultiplicityDataPersistValidator.class);
	}

	@Override
	public List<LabelAndMultiplicityData> buildInternal(FieldSet fieldSet, List<LabelAndMultiplicityDataEntity> data, EnumSet<AuthorizationFlags> authorizationFlags){
		return this.builderFactory.builder(LabelAndMultiplicityDataBuilder.class).authorize(authorizationFlags).build(fieldSet, data);
	}

	@Override
	protected LabelAndMultiplicityDataEntity applyPersistInternal(LabelAndMultiplicityDataPersist persist, LabelAndMultiplicityDataEntity data) {
		data.setMultipleSelect(persist.getMultipleSelect());
		return data;
	}

	@Override
	protected LabelAndMultiplicityDataPersist importExportMapDataToPersistInternal(LabelAndMultiplicityDataImportExport data, LabelAndMultiplicityDataPersist persist){
		persist.setMultipleSelect(data.getMultipleSelect());
		return persist;
	}

	@Override
	protected LabelAndMultiplicityDataImportExport dataToImportExportXmlInternal(LabelAndMultiplicityDataEntity data, LabelAndMultiplicityDataImportExport xml) {
		xml.setMultipleSelect(data.getMultipleSelect());
		return xml;
	}

	@Override
	protected boolean isMultiValueInternal(LabelAndMultiplicityDataEntity data) {
		return data.getMultipleSelect();
	}
}
