package eu.eudat.service.remotefetcher.config.entities;

import eu.eudat.commons.enums.ReferenceTypeExternalApiHTTPMethodType;

import java.util.List;

public interface SourceExternalApiConfiguration<RsConfig extends ResultsConfiguration<? extends ResultFieldsMappingConfiguration>, AuthConfig extends AuthenticationConfiguration, QConfig extends QueryConfig> extends  SourceBaseConfiguration {
    String getUrl();

    RsConfig getResults();

    String getPaginationPath();

    String getContentType();

    String getFirstPage();

    ReferenceTypeExternalApiHTTPMethodType getHttpMethod();

    String getRequestBody();

    String getFilterType();

    AuthConfig getAuth();

    List<QConfig> getQueries();
}


